// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#include <inttypes.h>
#include <memory.h>
#include "generated/telemetry.h"
#include "generated/receiver.h"
#include "generated/checksum.h"

/**
 * @note This function is only called when a debug command is received.
 * @note This function has to be provided by the ECom user.
 * @return Whether executing debug commands is currently enabled.
 */
extern bool areDebugCommandsEnabled(void);

/**
 * Print the formatted debug message.
 *
 * @note This function has to be provided by the ECom user.
 * @param format The format string.
 * @param ... Format values.
 */
extern void printDebug(const char* format, ...);

/**
 * Print the formatted error message.
 *
 * @note This function has to be provided by the ECom user.
 * @param format The format string.
 * @param ... Format values.
 */
extern void printError(const char* format, ...);

/**
 * @param config A configuration identifier.
 * @return The size of the corresponding configuration values type in bytes.
 */
static size_t getConfigValueSize(ConfigurationId config) {
    switch (config) {
    case PARACHUTE_TRIGGER_ALTITUDE:
        return sizeof(((Configuration*) NULL)->parachuteTriggerAltitude);
    case PARACHUTE_TRIGGER_PRESSURE:
        return sizeof(((Configuration*) NULL)->parachuteTriggerPressure);
    case ALTIMETER_MIN_POSSIBLE_VALUE:
        return sizeof(((Configuration*) NULL)->altimeterMinPossibleValue);
    case ALTIMETER_MAX_POSSIBLE_VALUE:
        return sizeof(((Configuration*) NULL)->altimeterMaxPossibleValue);
    case LANDED_PRESSURE_MIN:
        return sizeof(((Configuration*) NULL)->landedPressureMin);
    case LANDED_PRESSURE_MAX_CHANGE:
        return sizeof(((Configuration*) NULL)->landedPressureMaxChange);
    case STABLE_PRESSURE_LANDED_DURATION:
        return sizeof(((Configuration*) NULL)->stablePressureLandedDuration);
    case RECOVERY_TELEMETRY_SEND_PERIOD:
        return sizeof(((Configuration*) NULL)->recoveryTelemetrySendPeriod);
    case RECOVERY_TELEMETRY_LANDED_SEND_PERIOD:
        return sizeof(((Configuration*) NULL)->recoveryTelemetryLandedSendPeriod);
    case RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD:
        return sizeof(((Configuration*) NULL)->recoveryTelemetryStayingAliveSendPeriod);
    case STAY_ALIVE_TRIGGER_TIME:
        return sizeof(((Configuration*) NULL)->stayAliveTriggerTime);
    case PARACHUTE_DEPLOY_TRIGGER_TIME:
        return sizeof(((Configuration*) NULL)->parachuteDeployTriggerTime);
    case REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME:
        return sizeof(((Configuration*) NULL)->requiredConsecutiveParachuteDeploySensorTime);
    case GPS_FAILED_INIT_WAIT_TIME:
        return sizeof(((Configuration*) NULL)->GPSFailedInitWaitTime);
    case LANDED_MAX_ATTITUDE:
        return sizeof(((Configuration*) NULL)->landedMaxAttitude);
    case LANDED_MAX_ATTITUDE_CHANGE:
        return sizeof(((Configuration*) NULL)->landedMaxAttitudeChange);
    case STABLE_ATTITUDE_LANDED_DURATION:
        return sizeof(((Configuration*) NULL)->stableAttitudeLandedDuration);
    case DETUMBLE_CONTROLLER_P:
        return sizeof(((Configuration*) NULL)->detumbleControllerP);
    case DETUMBLE_CONTROLLER_I:
        return sizeof(((Configuration*) NULL)->detumbleControllerI);
    case DETUMBLE_CONTROLLER_D:
        return sizeof(((Configuration*) NULL)->detumbleControllerD);
    case ORIENTATION_CONTROLLER_P:
        return sizeof(((Configuration*) NULL)->orientationControllerP);
    case ORIENTATION_CONTROLLER_I:
        return sizeof(((Configuration*) NULL)->orientationControllerI);
    case ORIENTATION_CONTROLLER_D:
        return sizeof(((Configuration*) NULL)->orientationControllerD);
    case USE_MOTOR_SPEEDS_FOR_CONTROLLER:
        return sizeof(((Configuration*) NULL)->useMotorSpeedsForController);
    case HEARTBEAT_PERIOD:
        return sizeof(((Configuration*) NULL)->heartbeatPeriod);
    case PRE_LAUNCH_IMU_CALIBRATION_TIME:
        return sizeof(((Configuration*) NULL)->preLaunchIMUCalibrationTime);
    case PRE_LAUNCH_MOTOR_WARMUP_START_TIME:
        return sizeof(((Configuration*) NULL)->preLaunchMotorWarmupStartTime);
    case PRE_LAUNCH_MOTOR_WARMUP_END_TIME:
        return sizeof(((Configuration*) NULL)->preLaunchMotorWarmupEndTime);
    case MIN_ADCS_BATTERY_LEVEL:
        return sizeof(((Configuration*) NULL)->minADCSBatteryLevel);
    case GOPRO_OFF_TIME:
        return sizeof(((Configuration*) NULL)->GoProOffTime);
    case GOPRO_ON_TIME:
        return sizeof(((Configuration*) NULL)->GoProOnTime);
    case EJECT_ADCS_START_WAIT_TIME:
        return sizeof(((Configuration*) NULL)->ejectADCSStartWaitTime);
    case IMU_STATUS_CHECK_INTERVAL:
        return sizeof(((Configuration*) NULL)->IMUStatusCheckInterval);
    case SD_CARD_CHECK_INTERVAL:
        return sizeof(((Configuration*) NULL)->SDCardCheckInterval);
    case INITIAL_TELEMETRY_DELAY:
        return sizeof(((Configuration*) NULL)->initialTelemetryDelay);
    case LOG_FILE_PATH:
        return sizeof(((Configuration*) NULL)->logFilePath);
    case TARGET_ORIENTATIONS:
        return sizeof(((Configuration*) NULL)->targetOrientations);
    default:
        return 0;
    }
}
/**
 * Start an update to the configuration. To persist the changes, commitConfigUpdate must be called.
 * @see commitConfigUpdate
 * @note This function has to be provided by the ECom user.
 *
 * @return The live configuration object that can be changed or NULL on failure.
 */
extern Configuration* beginConfigUpdate(void);

/**
 * Finish and persist the changes to the configuration.
 * @see beginConfigUpdate
 * @note This function has to be provided by the ECom user.
 */
extern void commitConfigUpdate(void);

/**
 * Handle the telecommand to change a config item.
 *
 * @param config The config item to change.
 * @param value A pointer to the new value of the config item.
 */
static void handleCommandSetConfig(ConfigurationId configItem, const uint8_t* value) {
    Configuration* config = beginConfigUpdate();
    if (!config) {
        printError("Failed to update configuration: Failed start config update");
        return;
    }
    switch (configItem) {
    case PARACHUTE_TRIGGER_ALTITUDE:
        memcpy(&config->parachuteTriggerAltitude, value, sizeof(config->parachuteTriggerAltitude));
        break;
    case PARACHUTE_TRIGGER_PRESSURE:
        memcpy(&config->parachuteTriggerPressure, value, sizeof(config->parachuteTriggerPressure));
        break;
    case ALTIMETER_MIN_POSSIBLE_VALUE:
        memcpy(&config->altimeterMinPossibleValue, value,
            sizeof(config->altimeterMinPossibleValue));
        break;
    case ALTIMETER_MAX_POSSIBLE_VALUE:
        memcpy(&config->altimeterMaxPossibleValue, value,
            sizeof(config->altimeterMaxPossibleValue));
        break;
    case LANDED_PRESSURE_MIN:
        memcpy(&config->landedPressureMin, value, sizeof(config->landedPressureMin));
        break;
    case LANDED_PRESSURE_MAX_CHANGE:
        memcpy(&config->landedPressureMaxChange, value, sizeof(config->landedPressureMaxChange));
        break;
    case STABLE_PRESSURE_LANDED_DURATION:
        memcpy(&config->stablePressureLandedDuration, value,
            sizeof(config->stablePressureLandedDuration));
        break;
    case RECOVERY_TELEMETRY_SEND_PERIOD:
        memcpy(&config->recoveryTelemetrySendPeriod, value,
            sizeof(config->recoveryTelemetrySendPeriod));
        break;
    case RECOVERY_TELEMETRY_LANDED_SEND_PERIOD:
        memcpy(&config->recoveryTelemetryLandedSendPeriod, value,
            sizeof(config->recoveryTelemetryLandedSendPeriod));
        break;
    case RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD:
        memcpy(&config->recoveryTelemetryStayingAliveSendPeriod, value,
            sizeof(config->recoveryTelemetryStayingAliveSendPeriod));
        break;
    case STAY_ALIVE_TRIGGER_TIME:
        memcpy(&config->stayAliveTriggerTime, value, sizeof(config->stayAliveTriggerTime));
        break;
    case PARACHUTE_DEPLOY_TRIGGER_TIME:
        memcpy(&config->parachuteDeployTriggerTime, value,
            sizeof(config->parachuteDeployTriggerTime));
        break;
    case REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME:
        memcpy(&config->requiredConsecutiveParachuteDeploySensorTime, value,
            sizeof(config->requiredConsecutiveParachuteDeploySensorTime));
        break;
    case GPS_FAILED_INIT_WAIT_TIME:
        memcpy(&config->GPSFailedInitWaitTime, value, sizeof(config->GPSFailedInitWaitTime));
        break;
    case LANDED_MAX_ATTITUDE:
        memcpy(&config->landedMaxAttitude, value, sizeof(config->landedMaxAttitude));
        break;
    case LANDED_MAX_ATTITUDE_CHANGE:
        memcpy(&config->landedMaxAttitudeChange, value, sizeof(config->landedMaxAttitudeChange));
        break;
    case STABLE_ATTITUDE_LANDED_DURATION:
        memcpy(&config->stableAttitudeLandedDuration, value,
            sizeof(config->stableAttitudeLandedDuration));
        break;
    case DETUMBLE_CONTROLLER_P:
        memcpy(&config->detumbleControllerP, value, sizeof(config->detumbleControllerP));
        break;
    case DETUMBLE_CONTROLLER_I:
        memcpy(&config->detumbleControllerI, value, sizeof(config->detumbleControllerI));
        break;
    case DETUMBLE_CONTROLLER_D:
        memcpy(&config->detumbleControllerD, value, sizeof(config->detumbleControllerD));
        break;
    case ORIENTATION_CONTROLLER_P:
        memcpy(&config->orientationControllerP, value, sizeof(config->orientationControllerP));
        break;
    case ORIENTATION_CONTROLLER_I:
        memcpy(&config->orientationControllerI, value, sizeof(config->orientationControllerI));
        break;
    case ORIENTATION_CONTROLLER_D:
        memcpy(&config->orientationControllerD, value, sizeof(config->orientationControllerD));
        break;
    case USE_MOTOR_SPEEDS_FOR_CONTROLLER:
        memcpy(&config->useMotorSpeedsForController, value,
            sizeof(config->useMotorSpeedsForController));
        break;
    case HEARTBEAT_PERIOD:
        memcpy(&config->heartbeatPeriod, value, sizeof(config->heartbeatPeriod));
        break;
    case PRE_LAUNCH_IMU_CALIBRATION_TIME:
        memcpy(&config->preLaunchIMUCalibrationTime, value,
            sizeof(config->preLaunchIMUCalibrationTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_START_TIME:
        memcpy(&config->preLaunchMotorWarmupStartTime, value,
            sizeof(config->preLaunchMotorWarmupStartTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_END_TIME:
        memcpy(&config->preLaunchMotorWarmupEndTime, value,
            sizeof(config->preLaunchMotorWarmupEndTime));
        break;
    case MIN_ADCS_BATTERY_LEVEL:
        memcpy(&config->minADCSBatteryLevel, value, sizeof(config->minADCSBatteryLevel));
        break;
    case GOPRO_OFF_TIME:
        memcpy(&config->GoProOffTime, value, sizeof(config->GoProOffTime));
        break;
    case GOPRO_ON_TIME:
        memcpy(&config->GoProOnTime, value, sizeof(config->GoProOnTime));
        break;
    case EJECT_ADCS_START_WAIT_TIME:
        memcpy(&config->ejectADCSStartWaitTime, value, sizeof(config->ejectADCSStartWaitTime));
        break;
    case IMU_STATUS_CHECK_INTERVAL:
        memcpy(&config->IMUStatusCheckInterval, value, sizeof(config->IMUStatusCheckInterval));
        break;
    case SD_CARD_CHECK_INTERVAL:
        memcpy(&config->SDCardCheckInterval, value, sizeof(config->SDCardCheckInterval));
        break;
    case INITIAL_TELEMETRY_DELAY:
        memcpy(&config->initialTelemetryDelay, value, sizeof(config->initialTelemetryDelay));
        break;
    case LOG_FILE_PATH:
        memcpy(&config->logFilePath, value, sizeof(config->logFilePath));
        break;
    case TARGET_ORIENTATIONS:
        memcpy(&config->targetOrientations, value, sizeof(config->targetOrientations));
        break;
    default:
        printError("Got unknown config %u", (unsigned int) configItem);
    }
    commitConfigUpdate();
}

/**
 * @note This function has to be provided by the ECom user.
 * @return The current configuration.
 */
extern const Configuration* getConfig(void);

/**
 * Handle the telecommand to read a config item.
 *
 * @param config The config item to read.
 */
static void handleCommandGetConfig(ConfigurationId configItem, uint8_t* responseBuffer) {
    const Configuration* config = getConfig();
    switch (configItem) {
    case PARACHUTE_TRIGGER_ALTITUDE:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteTriggerAltitude,
            sizeof(config->parachuteTriggerAltitude));
        break;
    case PARACHUTE_TRIGGER_PRESSURE:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteTriggerPressure,
            sizeof(config->parachuteTriggerPressure));
        break;
    case ALTIMETER_MIN_POSSIBLE_VALUE:
        memcpy(responseBuffer, (const uint8_t*) &config->altimeterMinPossibleValue,
            sizeof(config->altimeterMinPossibleValue));
        break;
    case ALTIMETER_MAX_POSSIBLE_VALUE:
        memcpy(responseBuffer, (const uint8_t*) &config->altimeterMaxPossibleValue,
            sizeof(config->altimeterMaxPossibleValue));
        break;
    case LANDED_PRESSURE_MIN:
        memcpy(responseBuffer, (const uint8_t*) &config->landedPressureMin,
            sizeof(config->landedPressureMin));
        break;
    case LANDED_PRESSURE_MAX_CHANGE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedPressureMaxChange,
            sizeof(config->landedPressureMaxChange));
        break;
    case STABLE_PRESSURE_LANDED_DURATION:
        memcpy(responseBuffer, (const uint8_t*) &config->stablePressureLandedDuration,
            sizeof(config->stablePressureLandedDuration));
        break;
    case RECOVERY_TELEMETRY_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetrySendPeriod,
            sizeof(config->recoveryTelemetrySendPeriod));
        break;
    case RECOVERY_TELEMETRY_LANDED_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetryLandedSendPeriod,
            sizeof(config->recoveryTelemetryLandedSendPeriod));
        break;
    case RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetryStayingAliveSendPeriod,
            sizeof(config->recoveryTelemetryStayingAliveSendPeriod));
        break;
    case STAY_ALIVE_TRIGGER_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->stayAliveTriggerTime,
            sizeof(config->stayAliveTriggerTime));
        break;
    case PARACHUTE_DEPLOY_TRIGGER_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteDeployTriggerTime,
            sizeof(config->parachuteDeployTriggerTime));
        break;
    case REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME:
        memcpy(responseBuffer,
            (const uint8_t*) &config->requiredConsecutiveParachuteDeploySensorTime,
            sizeof(config->requiredConsecutiveParachuteDeploySensorTime));
        break;
    case GPS_FAILED_INIT_WAIT_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GPSFailedInitWaitTime,
            sizeof(config->GPSFailedInitWaitTime));
        break;
    case LANDED_MAX_ATTITUDE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedMaxAttitude,
            sizeof(config->landedMaxAttitude));
        break;
    case LANDED_MAX_ATTITUDE_CHANGE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedMaxAttitudeChange,
            sizeof(config->landedMaxAttitudeChange));
        break;
    case STABLE_ATTITUDE_LANDED_DURATION:
        memcpy(responseBuffer, (const uint8_t*) &config->stableAttitudeLandedDuration,
            sizeof(config->stableAttitudeLandedDuration));
        break;
    case DETUMBLE_CONTROLLER_P:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerP,
            sizeof(config->detumbleControllerP));
        break;
    case DETUMBLE_CONTROLLER_I:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerI,
            sizeof(config->detumbleControllerI));
        break;
    case DETUMBLE_CONTROLLER_D:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerD,
            sizeof(config->detumbleControllerD));
        break;
    case ORIENTATION_CONTROLLER_P:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerP,
            sizeof(config->orientationControllerP));
        break;
    case ORIENTATION_CONTROLLER_I:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerI,
            sizeof(config->orientationControllerI));
        break;
    case ORIENTATION_CONTROLLER_D:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerD,
            sizeof(config->orientationControllerD));
        break;
    case USE_MOTOR_SPEEDS_FOR_CONTROLLER:
        memcpy(responseBuffer, (const uint8_t*) &config->useMotorSpeedsForController,
            sizeof(config->useMotorSpeedsForController));
        break;
    case HEARTBEAT_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->heartbeatPeriod,
            sizeof(config->heartbeatPeriod));
        break;
    case PRE_LAUNCH_IMU_CALIBRATION_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchIMUCalibrationTime,
            sizeof(config->preLaunchIMUCalibrationTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_START_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchMotorWarmupStartTime,
            sizeof(config->preLaunchMotorWarmupStartTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_END_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchMotorWarmupEndTime,
            sizeof(config->preLaunchMotorWarmupEndTime));
        break;
    case MIN_ADCS_BATTERY_LEVEL:
        memcpy(responseBuffer, (const uint8_t*) &config->minADCSBatteryLevel,
            sizeof(config->minADCSBatteryLevel));
        break;
    case GOPRO_OFF_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GoProOffTime,
            sizeof(config->GoProOffTime));
        break;
    case GOPRO_ON_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GoProOnTime, sizeof(config->GoProOnTime));
        break;
    case EJECT_ADCS_START_WAIT_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->ejectADCSStartWaitTime,
            sizeof(config->ejectADCSStartWaitTime));
        break;
    case IMU_STATUS_CHECK_INTERVAL:
        memcpy(responseBuffer, (const uint8_t*) &config->IMUStatusCheckInterval,
            sizeof(config->IMUStatusCheckInterval));
        break;
    case SD_CARD_CHECK_INTERVAL:
        memcpy(responseBuffer, (const uint8_t*) &config->SDCardCheckInterval,
            sizeof(config->SDCardCheckInterval));
        break;
    case INITIAL_TELEMETRY_DELAY:
        memcpy(responseBuffer, (const uint8_t*) &config->initialTelemetryDelay,
            sizeof(config->initialTelemetryDelay));
        break;
    case LOG_FILE_PATH:
        memcpy(responseBuffer, (const uint8_t*) &config->logFilePath, sizeof(config->logFilePath));
        break;
    case TARGET_ORIENTATIONS:
        memcpy(responseBuffer, (const uint8_t*) &config->targetOrientations,
            sizeof(config->targetOrientations));
        break;
    default:
        printError("Got unknown config %u", (unsigned int) configItem);
    }
}

bool parseMessage(BufferAccessor* buffer, MessageHandler* handler) {
    for (size_t availableSize = buffer->availableBytes(buffer);
         availableSize >= sizeof(TelecommandMessageHeader);
         buffer->advance(buffer, 1), availableSize--) {
        uint8_t byteRead;
        if (!buffer->peek(buffer, &byteRead, sizeof(byteRead), 0) || byteRead != SYNC_BYTE_1 ||
            !buffer->peek(buffer, &byteRead, sizeof(byteRead), 1) || byteRead != SYNC_BYTE_2) {
            buffer->advance(buffer, 1);
            availableSize--;
            continue;
        }
        TelecommandMessageHeader header;
        if (!buffer->peek(buffer, &header, sizeof(header), 0)) {
            return false;
        }
        switch (header.type) {
        case COMMAND_SET_LAST_STATE: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t state;
            buffer->peek(buffer, &state, sizeof(state), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_LAST_STATE(state=%" PRIu8 ")", (uint8_t) state);
            handler->handleCommandSetLastState(handler, state);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_GET_LAST_STATE: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received GET_LAST_STATE");
            SystemState lastState = handler->handleCommandGetLastState(handler);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            ((SystemState*) responseBuffer)[0] = lastState;
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        case COMMAND_NEW_LOG_FILE: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received NEW_LOG_FILE");
            handler->handleCommandNewLogFile(handler);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_RESET_CHIP: {
            size_t dataSize = 4;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint32_t verificationCode;
            buffer->peek(buffer, &verificationCode, sizeof(verificationCode), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received RESET_CHIP(verificationCode=%" PRIu32 ")", verificationCode);
            handler->handleCommandResetChip(handler, verificationCode);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_CURRENT_STATE: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t state;
            buffer->peek(buffer, &state, sizeof(state), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_CURRENT_STATE(state=%" PRIu8 ")", (uint8_t) state);
            handler->handleCommandSetCurrentState(handler, state);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_GET_CURRENT_STATE: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received GET_CURRENT_STATE");
            SystemState state = handler->handleCommandGetCurrentState(handler);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            ((SystemState*) responseBuffer)[0] = state;
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        case COMMAND_SET_FLIGHT: {
            size_t dataSize = 5;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint32_t verificationCode;
            buffer->peek(buffer, &verificationCode, sizeof(verificationCode), sizeof(header));
            bool enable;
            buffer->peek(buffer, &enable, sizeof(enable), sizeof(header) + 4);
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_FLIGHT(verificationCode=%" PRIu32 ", enable=%" PRIu8 ")",
                verificationCode, enable);
            handler->handleCommandSetFlight(handler, verificationCode, enable);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_GET_FLIGHT: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received GET_FLIGHT");
            bool flightMode = handler->handleCommandGetFlight(handler);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            ((bool*) responseBuffer)[0] = flightMode;
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        case COMMAND_SET_PRE_LAUNCH_TIMER: {
            size_t dataSize = 4;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t timer;
            buffer->peek(buffer, &timer, sizeof(timer), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_PRE_LAUNCH_TIMER(timer=%" PRIu32 ")", timer.ms);
            handler->handleCommandSetPreLaunchTimer(handler, timer);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_VIDEO_ENABLED: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            bool enabled;
            buffer->peek(buffer, &enabled, sizeof(enabled), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_VIDEO_ENABLED(enabled=%" PRIu8 ")", enabled);
            handler->handleCommandSetVideoEnabled(handler, enabled);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_RESET_RECOVERY: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received RESET_RECOVERY");
            handler->handleCommandResetRecovery(handler);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_MOTOR_ENABLED: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            bool enabled;
            buffer->peek(buffer, &enabled, sizeof(enabled), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received MOTOR_ENABLED(enabled=%" PRIu8 ")", enabled);
            handler->handleCommandMotorEnabled(handler, enabled);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_MOTOR_WARMUP: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            bool enabled;
            buffer->peek(buffer, &enabled, sizeof(enabled), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received MOTOR_WARMUP(enabled=%" PRIu8 ")", enabled);
            handler->handleCommandMotorWarmup(handler, enabled);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_CONFIG: {
            size_t dataSize = 0;
            uint8_t config;
            if (!buffer->peek(buffer, &config, sizeof(config), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint8_t);
            size_t configSize = getConfigValueSize((ConfigurationId) config);
            if (configSize == 0) {
                printError("Invalid config value: %u", (unsigned int) config);
                buffer->advance(buffer, 2);
                availableSize -= 2;
                continue;
            }
            uint8_t value[configSize];
            if (!buffer->peek(buffer, &value, sizeof(value), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += configSize;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_CONFIG(config=%" PRIu8 ")", (uint8_t) config);
            handleCommandSetConfig(config, value);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_GET_CONFIG: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t config;
            buffer->peek(buffer, &config, sizeof(config), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received GET_CONFIG(config=%" PRIu8 ")", (uint8_t) config);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            handleCommandGetConfig(config, responseBuffer);
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        case COMMAND_SET_PWM: {
            size_t dataSize = 8;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            pwm_t value;
            buffer->peek(buffer, &value, sizeof(value), sizeof(header));
            static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_PWM(value=%f)", value.pwm);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSetPwm(handler, value);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_RPM: {
            size_t dataSize = 8;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            rpm_t value;
            buffer->peek(buffer, &value, sizeof(value), sizeof(header));
            static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_RPM(value=%f)", value.rpm);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSetRpm(handler, value);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_ADCS_MODE: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t mode;
            buffer->peek(buffer, &mode, sizeof(mode), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_ADCS_MODE(mode=%" PRIu8 ")", (uint8_t) mode);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSetAdcsMode(handler, mode);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_DEPLOY_PARACHUTE: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received DEPLOY_PARACHUTE");
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandDeployParachute(handler);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SEND_IRIDIUM_MESSAGE: {
            size_t dataSize = 0;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SEND_IRIDIUM_MESSAGE");
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSendIridiumMessage(handler);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_CALIBRATE_IMU: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t imu;
            buffer->peek(buffer, &imu, sizeof(imu), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received CALIBRATE_IMU(imu=%" PRIu8 ")", imu);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            bool calibrationResult = handler->handleCommandCalibrateImu(handler, imu);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            ((bool*) responseBuffer)[0] = calibrationResult;
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        case COMMAND_SET_PAYLOAD_VIDEO: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            bool enabled;
            buffer->peek(buffer, &enabled, sizeof(enabled), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_PAYLOAD_VIDEO(enabled=%" PRIu8 ")", enabled);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSetPayloadVideo(handler, enabled);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SET_RECOVERY_STATE: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t state;
            buffer->peek(buffer, &state, sizeof(state), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SET_RECOVERY_STATE(state=%" PRIu8 ")", (uint8_t) state);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            handler->handleCommandSetRecoveryState(handler, state);
            sendTelemetryAcknowledge(header.counter);
            return true;
        }
        case COMMAND_SEND_COMMAND: {
            size_t dataSize = 0;
            uint16_t size;
            if (!buffer->peek(buffer, &size, sizeof(size), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint16_t);
            if (size > 512) {
                handler->errorHandler(handler, DYNAMIC_SIZE_TOO_LARGE);
                continue;
            }
            char command[size];
            if (!buffer->peek(buffer, &command, sizeof(command), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += size;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            printDebug("Received SEND_COMMAND(size=%" PRIu16 ", command=%c)", size, command);
            if (!areDebugCommandsEnabled()) {
                return true;
            }
            int32_t exitCode = handler->handleCommandSendCommand(handler, size, command);
            uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
            ((int32_t*) responseBuffer)[0] = exitCode;
            sendTelemetryResponse(header.counter, responseBuffer);
            return true;
        }
        default:
            handler->errorHandler(handler, INVALID_MESSAGE);
        }
    }
    return false;
}
